`define INSN_ADD_SP_IMM8		9'b011101000

`ifdef EXECUTE
	`INSN_ADD_SP_IMM8: begin
		case (cycle)
		0:	begin
				`EXEC_INC_PC
			end
		1:	begin
				`EXEC_READ(`_PC)
			end
		3:	begin
				`EXEC_NEWCYCLE
				`EXEC_INC_PC
			end
		endcase
	end
`endif

`ifdef WRITEBACK
	`INSN_ADD_SP_IMM8: begin
		case (cycle)
		2:	`_SP <= `_SP + {rdata[7] ? 8'hFF : 8'h00, rdata};
		endcase
	end
`endif
